uniform float seconds;
uniform sampler2D logotex;
uniform sampler2D raspitex;
varying vec2 uv, uv01;
#if 0

#define PI2 (2.0*3.14159265)

void main( void ) {
	// a nice -1..1 pos box as is on the screen
	vec2 pos = gl_FragCoord.xy * resolution_2_inv.xy - vec2(1.0, 1.0);
	// .. and a [0..1] helper
	vec2 pos_01 = 0.5 * pos + 0.5;

	vec4 grad = vec4(pos_01, 0.5*sin(0.3 * PI2 * seconds) + 0.5, 1.0);
	vec4 pix = texture2D(tex, pos_01);
	gl_FragColor = 0.5 * (grad + pix);
}
#endif
void main(void)
{
#if 0
	float aspectRatio = iResolution.x / iResolution.y;
	vec2 uv = gl_FragCoord.xy / iResolution.xy;
	vec2 xy = uv * vec2(1024.0, 1024.0 / aspectRatio ) - vec2( 512.0, 512.0 / aspectRatio );
#endif
	vec2 xy = uv * 512.0;

	float distSq = xy.x * xy.x + xy.y * xy.y;
	float dist = sqrt( distSq );
	if( dist < 140.0 )
	{
		gl_FragColor = vec4( 0.3, 0.3, 1.0, 1.0 ) + vec4(texture2D(raspitex, uv * 2.0).rgb, 0.0);
	}
	else if( dist < 220.0 )
	{
		float ratio = dist / 220.0;
		float color = ratio * ratio;

		gl_FragColor = vec4( 1.0, 1.0 -color, 1.0-color, 1.0 );
	}
	else if( dist < 360.0 )
	{
		float ratio = dist / 360.0;
		float color = ratio * ratio;

		gl_FragColor = vec4( 1.0, 1.0 -color, 1.0-color, 1.0 );
	}
	else if( dist < 500.0 )
	{
		float ratio = dist / 500.0;
		float color = ratio * ratio;

		gl_FragColor = vec4( 1.0, 1.0 -color, 1.0-color, 1.0 );
	}
	else if( dist < 6400.0 )
	{
		float ratio = dist / 640.0;
		float color = ratio * ratio;

		gl_FragColor = vec4( 1.0, 1.0 -color, 1.0-color, 1.0 );
	}
	else
	{
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
	}
}


